<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xmi="http://www.omg.org/XMI"
  xmlns:applicationclientext="applicationclientext.xmi"
  xmlns:ejbext="ejbext.xmi"
  xmlns:webappext="webappext.xmi"
  xmlns:appdeployment="http://www.ibm.com/websphere/appserver/schemas/5.0/appdeployment.xmi"
  xmlns:com.ibm.ejs.models.base.bindings.webappbnd="webappbnd.xmi"
  xmlns:com.ibm.ejs.models.base.bindings.ejbbnd="ejbbnd.xmi"
  xmlns:resources="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.xmi"
  xmlns:resources.j2c="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.j2c.xmi"
  xmlns:resources.jdbc="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.jdbc.xmi"
  xmlns:resources.jms="http://www.ibm.com/websphere/appserver/schemas/5.0/resources.jms.xmi" >
<xsl:import href="copy.xsl"/>

<!-- Remove accessEntentEntities with the following types:
     xmi:type="ejbext:DeferredOperation"
     xmi:type="ejbext:PartialOperation"
     xmi:type="ejbext:VerifyReadOnlyData"

     DR: LIDB2932.16
-->
<xsl:template match="ejbext:EJBJarExtension/appliedAccessIntents/accessIntentEntries">
  <xsl:if test="not(@xmi:type='ejbext:DeferredOperation' or
                    @xmi:type='ejbext:PartialOperation' or
                    @xmi:type='ejbext:VerifyReadOnlyData')">
    <xsl:call-template name="copy"/>
  </xsl:if>
</xsl:template>

<!-- Remove globalTransaction element from ejbExtensions and extendedServlets
     DR: 2505.50
-->
<xsl:template match="ejbext:EJBJarExtension/ejbExtensions/globalTransaction"/>
<xsl:template match="webappext:WebAppExtension/extendedServlets/globalTransaction"/>

<!-- Remove transactionApplicationClientExtension from ApplicationClientExtension
     DR: 2505.50
-->
<xsl:template match="applicationclientext:ApplicationClientExtension/transactionApplicationClientExtension"/>

<!-- Remove sequenceGroups from ibm-ejb-jar-ext.xmi
     DR: 1664.14
-->
<xsl:template match="ejbext:EJBJarExtension/sequenceGroups"/>

<!-- Remove new Entity Bean Extensions from ibm-ejb-jar-ext.xmi:
        disableEJBStoreForNonDirtyBeans
        disableFlushBeforeFind
        lightweightLocal
     DR: LIDB3795-56, defect 341280
-->
<xsl:template match="ejbext:EJBJarExtension/ejbExtensions/@disableEJBStoreForNonDirtyBeans"/>
<xsl:template match="ejbext:EJBJarExtension/ejbExtensions/@disableFlushBeforeFind"/>
<xsl:template match="ejbext:EJBJarExtension/ejbExtensions/@lightweightLocal"/>

<!-- Remove drsSettings element from deployment.xml
     Remove enableSFSBFailover attribute from configs
     Remove overrideDefaultDRSSettings attribute from configs
     DR: 2018.17, defect 271408
-->
<xsl:template match="appdeployment:Deployment/deployedObject/configs/drsSettings"/>
<xsl:template match="appdeployment:Deployment/deployedObject/configs/@enableSFSBFailover"/>
<xsl:template match="appdeployment:Deployment/deployedObject/configs/@overrideDefaultDRSSettings"/>
<xsl:template match="appdeployment:Deployment/deployedObject/modules/configs/drsSettings"/>
<xsl:template match="appdeployment:Deployment/deployedObject/modules/configs/@enableSFSBFailover"/>
<xsl:template match="appdeployment:Deployment/deployedObject/modules/configs/@overrideDefaultDRSSettings"/>

<!-- Remove a boolean 'zeroBinaryCopy' and a properties list from deployment.xml
     DR: 2577.20
-->
<xsl:template match="appdeployment:Deployment/deployedObject/@zeroBinaryCopy"/>
<xsl:template match="appdeployment:Deployment/deployedObject/classloader/properties"/>

<!-- Remove appContextIDForSecurity attribute from deployment.xml
    DR: 130.31
-->
<xsl:template match="appdeployment:Deployment/deployedObject/@appContextIDForSecurity"/>

<!-- Remove zeroEarCopy, filePermisison, allowDisplatchRemoteInclude, allowServiceRemoteInclude
     from deployment.xml
     FROM DR: 3720
     -->
<xsl:template match="appdeployment:Deployment/deployedObject/@zeroEarCopy"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@filePermission"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@allowDispatchRemoteInclude"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@allowServiceRemoteInclude"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@asyncRequestDispatchType"/>

<!-- 336028 Remove modules/classloader and properties element from deployment.xml -->
<xsl:template match="appdeployment:Deployment/deployedObject/modules/classloader"/>
<xsl:template match="appdeployment:Deployment/deployedObject/properties"/>


<!-- Remove deploymentDescriptor from a resourceAdapter module in deployment.xml
     defect: 214100
-->
<xsl:template match="appdeployment:Deployment/deployedObject/modules/resourceAdapter/deploymentDescriptor"/>

<!-- Remove backgroundApplication attribute.
     defect: 238589
-->
<xsl:template match="appdeployment:Deployment/deployedObject/@backgroundApplication"/>

<!-- Remove these elements from ibm-ejb-jar-bnd.xmi
     defect: 228756
-->
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/activationSpecJndiName"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/activationSpecAuthAlias"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/destinationJndiName"/>

<!-- Remove these elements from ibm-ejb-jar-bnd.xmi
     defect: 235809  and 568145
-->
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/defaultDatasource/@loginConfigurationName"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/defaultDatasource/@properties"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/defaultCMPConnectionFactory/@loginConfigurationName"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/defaultCMPConnectionFactory/@properties"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/datasource/@loginConfigurationName"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/datasource/@properties"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/cmpConnectionFactory/@loginConfigurationName"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/cmpConnectionFactory/@properties"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/resRefBindings/@loginConfigurationName"/>
<xsl:template match="com.ibm.ejs.models.base.bindings.ejbbnd:EJBJarBinding/ejbBindings/resRefBindings/@properties"/>

<!-- Remove these elements from ibm-web-bnd.xmi 
      defect 568145
-->
<xsl:template match="com.ibm.ejs.models.base.bindings.webappbnd:WebAppBinding/resRefBindings/@properties"/>


<!-- Remove expandSynchronously, recycleOnUpdate, startOnDistribute, autoLink
     from deployment.xml
     FROM DR: 3292-29
     -->
<xsl:template match="appdeployment:Deployment/deployedObject/@expandSynchronously"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@recycleOnUpdate"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@startOnDistribute"/>
<xsl:template match="appdeployment:Deployment/deployedObject/@autoLink"/>

<!-- Remove J2CResourceAdapter v7.0 WCCM features from deployment.xml
     FROM Defect: 625103 (See LIDB 4500, 3390)
     -->
<xsl:template match="resourceAdapter/@isolatedClassLoader"/>
<xsl:template match="resourceAdapter/@hACapability"/>
<xsl:template match="resourceAdapter/@isEnableHASupport"/>
<xsl:template match="resourceAdapter/@singleton"/>

<xsl:template match="resources:ConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources:ConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources:ConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources:ConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources:ConnectionFactory/@providerType"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.j2c:J2CConnectionFactory/@providerType"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/preTestConfig"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/@manageCachedHandles"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.j2c:J2CResourceAdapter/@providerType"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jdbc:CMPConnectionFactory/@providerType"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/preTestConfig"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/@manageCachedHandles"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jdbc:JDBCProvider/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jdbc:JDBCProvider/@providerType"/>
<xsl:template match="resources.jdbc:DataSource/factories/preTestConfig"/>
<xsl:template match="resources.jdbc:DataSource/factories/@manageCachedHandles"/>
<xsl:template match="resources.jdbc:DataSource/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jdbc:DataSource/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jdbc:DataSource/@providerType"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/preTestConfig"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/@manageCachedHandles"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jms:JMSConnectionFactory/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jms:JMSConnectionFactory/@providerType"/>
<xsl:template match="resources.jms:JMSProvider/factories/preTestConfig"/>
<xsl:template match="resources.jms:JMSProvider/factories/@manageCachedHandles"/>
<xsl:template match="resources.jms:JMSProvider/factories/@logMissingTransactionContext"/>
<xsl:template match="resources.jms:JMSProvider/factories/@xaRecoveryAuthAlias"/>
<xsl:template match="resources.jms:JMSProvider/@providerType"/>



</xsl:stylesheet>
